package org.gcube.application.geoportal.service;

import org.gcube.application.geoportal.service.rest.GuardedMethod;
import org.gcube.application.geoportal.service.utils.Serialization;
import org.glassfish.jersey.test.JerseyTest;
import org.junit.BeforeClass;

import javax.ws.rs.core.Application;
import javax.ws.rs.core.Response;

public class BasicServiceTestUnit extends JerseyTest {

	
	
	@Override
	protected Application configure() {
		return new GeoPortalService();
	}
	
	protected static String scope="/gcube/devsec/devVRE";
	
	@BeforeClass
	public static void init() {

		GuardedMethod.addPreoperation(new Runnable() {
			@Override
			public void run() {
				TokenSetter.set(scope);
			}
		});


/*
		ImplementationProvider.get().setStorageProvider(new StorageClientProvider() {
			@Override
			public IClient getObject() throws ConfigurationException {
				TokenSetter.set(scope);
				return super.getObject();
			}
		});


		ImplementationProvider.get().setMongoConnectionProvider(new MongoConnectionProvider() {
			@Override
			public org.gcube.application.geoportal.service.model.internal.db.MongoConnection getObject() throws ConfigurationException {
				TokenSetter.set(scope);
				return super.getObject();
			}
		});

		ImplementationProvider.get().setMongoClientProvider(new MongoClientProvider() {
			@Override
			public MongoClient getObject() throws ConfigurationException {
				TokenSetter.set(scope);
				return super.getObject();
			}
		});

		ImplementationProvider.get().setDbProvider(new PostgisConnectionProvider() {
			@Override
			public PostgisDBManager getObject() throws ConfigurationException {
				TokenSetter.set(scope);
				return super.getObject();
			}
		});*/
	}
	
	
	protected static<T> T check(Response resp, Class<T> clazz) throws Exception {
		String resString=resp.readEntity(String.class);
		if(resp.getStatus()<200||resp.getStatus()>=300)
			throw new Exception("RESP STATUS IS "+resp.getStatus()+". Message : "+resString);
		System.out.println("Resp String is "+resString);
		if(clazz!=null)
			if (clazz==String.class)
				return (T) resString;
			else
				return Serialization.read(resString, clazz);
		else return null;
	}
}
