package org.gcube.application.geoportal.service.ws;

import org.gcube.application.geoportal.service.TokenSetter;
import org.gcube.common.storagehub.client.dsl.StorageHubClient;
import org.gcube.common.storagehub.model.exceptions.StorageHubException;
import org.gcube.common.storagehub.model.items.*;

public class DescribeWSFolder {

    public static void main(String[] args) throws StorageHubException {
        String context="/gcube/devsec/devVRE";
        String folderID="fea4a885-7e60-4294-83d0-82162e7462f4";


        TokenSetter.set(context);
        StorageHubClient shc = new StorageHubClient();
        FolderItem folder=shc.open(folderID).asFolder().get();

        System.out.println("PATH : "+folder.getPath());
        System.out.println("HIDDEN : "+folder.isHidden());
        System.out.println("Description : "+folder.getDescription());

        System.out.println("Listing... ");
        for (Item item :  shc.open(folderID).asFolder().list().getItems()) {
            System.out.println("name:" + item.getName() + " is a File?: " + (item instanceof AbstractFileItem));
            System.out.println("name:" + item.getName() + " is a folder?: " + (item instanceof FolderItem));
            System.out.println("name:" + item.getName() + " is a shared folder?: " + (item instanceof SharedFolder));
            System.out.println("name:" + item.getName() + " is a VRE folder?: " + (item instanceof VreFolder));
        }
    }
}
